#include "allegro.h"
#include "levels.h"

//add pushable objects
//don't allow people to hang out of portals
//game ending
//max momentum, make so that there will be traps at the location where you would expect someone's momentum to run out &c.
//add pause after finishing level

void init();
void deinit();

int min(int a, int b)
{
	if (a<b) return a;
	else return b;    
}

int max(int a,int b)
{
	if (a>b)  return a;
	else return b;
}
const int pan = 128;
const int pitch = 1000;

int mode = 1;// 0 2d, 1 horizontal, 2 vertical

SAMPLE *sound[3];
const int S_FINISH=0;
const int S_SHOOT=1;
const int S_FAIL=2;

int colorkey[21];

int curlevel;
int px;
int py;  
int pm;
int pmdir;

const int displaysize=120;
const int leveloffset=0;
const int displayoffsety=0; //for y only
const int displayoffsetx=0;

const int tilesize=30;
int display[displaysize][displaysize];

BITMAP *buffer;


/* FRAMERATE CONTROL*/

void initlevel()
{
	for (int i=0;i<levelsize;i++)
		for (int j=0;j<levelsize;j++)
			if (level[curlevel][j][i]==S)
			{
				px=i;
				py=j;
			}	
	
	mode = 1;		
}

bool canmove(int x, int y)
{
	//	return ((level[curlevel][y][x]==2)||(level[curlevel][y][x]==8)||(level[curlevel][y][x]==11)||(level[curlevel][y][x]==14)||(level[curlevel][y][x]==15)||(level[curlevel][y][x]==16));
	if ((x>=0)&&(y>=0)&&(x<levelsize)&&(y<levelsize)) 
	{
		if (mode==1)//hor; scan the vertical rows
		{
			
			//scan on the player's row
			if (level[curlevel][py][x]>=W)
				return false;
			
			//scan from player down
			for (int j=py+1;j<levelsize;j++)
			{
				if (level[curlevel][j][x]==U || level[curlevel][j][x]==Q || level[curlevel][j][x]==E)
					break;				
				else if (level[curlevel][j][x]>=W)
					return false;
			}
			//scan from player up
			for (int j=py-1;j>=0;j--)
			{
				if (level[curlevel][j][x]==D || level[curlevel][j][x]==Z || level[curlevel][j][x]==C)
					break;				
				else if (level[curlevel][j][x]>=W)
					return false;
			}
			
		}
		else if (mode==2)//vert
		{
			
			//scan on the player's column
			if (level[curlevel][y][px]>=W)
				return false;
			
			//scan from player to the left
			for (int i=px-1;i>=0;i--)
			{
				if (level[curlevel][y][i]==R || level[curlevel][y][i]==E || level[curlevel][y][i]==C)
					break;
				else if (level[curlevel][y][i]>=W)
					return false;
			}	
			
			//and from player to right
			for (int i=px+1;i<levelsize;i++)
			{
				if (level[curlevel][y][i]==L || level[curlevel][y][i]==Q || level[curlevel][y][i]==Z)
					break;
				else if (level[curlevel][y][i]>=W)
				return false;
			}	
			
		}
		
		//otherwise return true
		return true;
	}
	else return false;
}
/*
 bool canshoot(int x, int y)
 {
 return ((level[curlevel][y][x]==2)||(level[curlevel][y][x]==8)||(level[curlevel][y][x]==9)||(level[curlevel][y][x]==14)||(level[curlevel][y][x]==15)||(level[curlevel][y][x]==16));   
 }*/

volatile unsigned int frames, fps;
void second_counter(void)
{
	fps=frames;
	frames=0;
} END_OF_FUNCTION(second_counter);
int timewaster_delay;
extern void do_prog(void);

volatile unsigned int ticks;
void ticker(void)
{
	++ticks;
} END_OF_FUNCTION(ticker);


int main() {
    
	
	init();
	
	
	
	int shotcolor[2];
	shotcolor[0]=6;
	shotcolor[1]=7;
    
	while (!key[KEY_ESC]) 
	{
		//reset level
		/*          if (key[KEY_Q])
		 {
		 initlevel();
		 }          */
		
		
		
		{
			//clear screen contents
			for (int i=0;i<displaysize;i++)
				for (int j=0;j<displaysize;j++)
					display[i][j]=bggrey;
			//momentum stuff
			
			
			if (mode==1)
			{
				//introduce acceleration later  
				if (key[KEY_RIGHT])
				{
					if  (canmove(px+1,py))
						px++; 
				}
				if (key[KEY_LEFT])
				{
					if (canmove(px-1,py))               
						px--; 
				}
			}			
			else if (mode==2)
			{
				if (key[KEY_DOWN])
				{
					if (canmove(px,py+1))
					{
						py++; 
					}
				}					
				//temp move up control to test stuff
				if (key[KEY_UP])
				{
					if  (canmove(px,py-1))
						py--; 
				}
			}
			else if (mode==0)
			{
				if (key[KEY_UP]||key[KEY_DOWN]) //mode to vertical
				{
					
					//WILL HAVE TO CHANGE THESE AS WELL?  YIP
					bool block=false;
					
					//check from player to left first					
					for (int i=px-1;i>=0;i--)
					{
						if (level[curlevel][py][i]==R || level[curlevel][py][i]==E || level[curlevel][py][i]==C)
							break;
						else if (level[curlevel][py][i]>=W)
							block=true;
					}
					
					//check from player to right					
					for (int i=px+1;i<levelsize;i++)
					{
						if (level[curlevel][py][i]==L || level[curlevel][py][i]==Z || level[curlevel][py][i]==Q)
							break;
						else if (level[curlevel][py][i]>=W)
							block=true;
					}
					
					if (!block)
					{
						mode=2;
						play_sample(sound[S_SHOOT], 255, pan, pitch, FALSE);				
					}
					else
						play_sample(sound[S_FAIL], 255, pan, pitch, FALSE);																		
				}
				else if (key[KEY_LEFT]||key[KEY_RIGHT])//mode to horizontal
				{
					bool block=false;
					
					//check from player to top first
					for (int j=py-1;j>=0;j--)
					{
						if (level[curlevel][j][px]==D || level[curlevel][j][px]==Z || level[curlevel][j][px]==C)
							break;
						else if (level[curlevel][j][px]>=W)
							block=true;
					}
					//check from player to bottoom
					for (int j=py+1;j<levelsize;j++)
					{
						if (level[curlevel][j][px]==U || level[curlevel][j][px]==Q || level[curlevel][j][px]==E)
							break;
						else if (level[curlevel][j][px]>=W)
							block=true;
					}
					
					
					if (!block)
					{
						mode=1;					
						play_sample(sound[S_SHOOT], 255, pan, pitch, FALSE);											
					}
					else
						play_sample(sound[S_FAIL], 255, pan, pitch, FALSE);											
				}					
			}
			
			
			if (mode>0)
			{
				if (key[KEY_SPACE])
				{
					mode=0;
					play_sample(sound[S_SHOOT], 255, pan, pitch, FALSE);				
				}
			}
			
			
			
		}
		
		if (mode==1)//horizontal
		{
			bool endintersect=false;
			
			//first check the player's position
			
			if (level[curlevel][py][px]==F)
				endintersect=true;

			//from the player up
			for (int j=py-1;j>=0;j--)
			{
				if (level[curlevel][j][px]==F)
					endintersect=true;
				else if (level[curlevel][j][px]>=W)
					break;
			}

			//from the player down
			for (int j=py+1;j<levelsize;j++)
			{
				if (level[curlevel][j][px]==F)
					endintersect=true;
				else if (level[curlevel][j][px]>=W)
					break;				
			}
			
			if (endintersect)
			{
				curlevel++;
				initlevel();
				play_sample(sound[S_FINISH], 255, pan, pitch, FALSE);				
			}
		}
		if (mode==2)//vertical
		{
			bool endintersect=false;
			
			//first check the player's position
			
			if (level[curlevel][py][px]==F)
				endintersect=true;
			
			//from the player up
			for (int i=px-1;i>=0;i--)
			{
				if (level[curlevel][py][i]==F)
					endintersect=true;
				else if (level[curlevel][py][i]>=W)
					break;
			}
			
			//from the player down
			for (int i=px+1;i<levelsize;i++)
			{
				if (level[curlevel][py][i]==F)
					endintersect=true;
				else if (level[curlevel][py][i]>=W)
					break;				
			}
			
			if (endintersect)
			{
				curlevel++;
				initlevel();
				play_sample(sound[S_FINISH], 255, pan, pitch, FALSE);				
			}
		}			
		
		//draw basic level     
		if (mode==0)
		{
			for (int i=0;i<levelsize;i++)
				for (int j=0;j<levelsize;j++)
				{
					if (level[curlevel][j][i]==F)
						display[i+leveloffset][j+leveloffset]=F;
					else if (level[curlevel][j][i]>=W)
						display[i+leveloffset][j+leveloffset]=level[curlevel][j][i];
					else
						display[i+leveloffset][j+leveloffset]=0;
				}
		}
		else if (mode==1) //horizontal
		{
			for (int i=0;i<levelsize;i++)
			{	
				int candidate=0;
				
				//check the row the player's on for anything
				
				if (level[curlevel][py][i]>=W) 
					candidate=W;
				else if (level[curlevel][py][i]==F)							
					candidate=F;				
				
				//first trace down from player position
				for (int j=py+1;j<levelsize;j++)
					if (level[curlevel][j][i]>0)
					{
						if ((level[curlevel][j][i]==F) && (candidate<W))
							candidate=F;//finishing point can be overwritten by others
						if (level[curlevel][j][i]==U || level[curlevel][j][i]==Q || level[curlevel][j][i]==E )//if there's an up alcove
						{
							if (candidate==0) candidate=G;
							break;
						}
						if (level[curlevel][j][i]>=W)//for any other sort of wall
						{
							candidate=W;
							break;
						}
					}
				
				//then up				
				for (int j=py-1;j>=0;j--)
					if (level[curlevel][j][i]>0)
					{
						if ((level[curlevel][j][i]==F) && (candidate<W))
							candidate=F;//finishing point can be overwritten by others
						if (level[curlevel][j][i]==D || level[curlevel][j][i]==Z || level[curlevel][j][i]==C)//if there's an up alcove
						{
							if (candidate==0) candidate=G;
							break;
						}
						if (level[curlevel][j][i]>=W)//for any other sort of wall
						{
							candidate=W;
							break;
						}
					}
				
				display[i+leveloffset][py+leveloffset]=candidate;			
				
			}
		}	
		else if (mode==2) //vertical
		{
			

			
			for (int j=0;j<levelsize;j++)
			{	
				int candidate=0;
				
				
				//check the column the player's on for anything
				if (level[curlevel][j][px]>=W) 
					candidate=W;
				else if (level[curlevel][j][px]==F)							
					candidate=F;
				
				//scan from player to the left
				for (int i=px-1;i>=0;i--)
					if (level[curlevel][j][i]>0)
					{
						if ((level[curlevel][j][i]==F) &&(candidate<W))
							candidate=F;
						if (level[curlevel][j][i]==R || level[curlevel][j][i]==E || level[curlevel][j][i]==C)
						{
							if (candidate==0) candidate=G;
							break;
						}
						if (level[curlevel][j][i]>=W)							
							candidate=W;
					}
				//and to the right
				//scan from player to the left
				for (int i=px+1;i<levelsize;i++)
					if (level[curlevel][j][i]>0)
					{
						if ((level[curlevel][j][i]==F) &&(candidate<W))
							candidate=F;
						if (level[curlevel][j][i]==L || level[curlevel][j][i]==Q || level[curlevel][j][i]==Z)
						{
							if (candidate==0) candidate=G;
							break;
						}
						if (level[curlevel][j][i]>=W)							
							candidate=W;
					}
				
				display[px+leveloffset][j+leveloffset]=candidate;			
			}
		}
		
		//draw player
		display[px+leveloffset][py+leveloffset]=pcol;
		
		//draw screen contents;
		//          blit(bg,buffer, 0,0,0,0,800,600);
		clear_to_color(buffer,colorkey[bggrey]);    
		for (int i=displayoffsetx;i<displaysize-displayoffsetx;i++)
			for (int j=displayoffsety;j<displaysize-displayoffsety;j++)
			{
				int square=display[i][j];
				rectfill(buffer,(i-displayoffsetx)*tilesize+100,(j-displayoffsety)*tilesize,(i-displayoffsetx)*tilesize+tilesize-1+100,(j-displayoffsety)*tilesize+tilesize-1,colorkey[square]);
				
				switch (square)
					{
						case U://up
							rectfill(buffer,(i-displayoffsetx)*tilesize+100+tilesize/4,(j-displayoffsety)*tilesize,(i-displayoffsetx)*tilesize+tilesize-1+100-tilesize/4,(j-displayoffsety)*tilesize+tilesize-1-tilesize/4,makecol(0,0,0));							
							break;
						case D://down
							rectfill(buffer,(i-displayoffsetx)*tilesize+100+tilesize/4,(j-displayoffsety)*tilesize+tilesize/4,(i-displayoffsetx)*tilesize+tilesize-1+100-tilesize/4,(j-displayoffsety)*tilesize+tilesize-1,makecol(0,0,0));							
							break;
						case L://left
							rectfill(buffer,(i-displayoffsetx)*tilesize+100,(j-displayoffsety)*tilesize+tilesize/4,(i-displayoffsetx)*tilesize+tilesize-1+100-tilesize/4,(j-displayoffsety)*tilesize+tilesize-1-tilesize/4,makecol(0,0,0));							
							break;
						case R://right
							rectfill(buffer,(i-displayoffsetx)*tilesize+100+tilesize/4,(j-displayoffsety)*tilesize+tilesize/4,(i-displayoffsetx)*tilesize+tilesize-1+100,(j-displayoffsety)*tilesize+tilesize-1-tilesize/4,makecol(0,0,0));							
							break;
						case Q://right
							rectfill(buffer,(i-displayoffsetx)*tilesize+100,(j-displayoffsety)*tilesize,(i-displayoffsetx)*tilesize+tilesize-1+100-tilesize/4,(j-displayoffsety)*tilesize+tilesize-1-tilesize/4,makecol(0,0,0));							
							break;	
						case E://right
							rectfill(buffer,(i-displayoffsetx)*tilesize+100+tilesize/4,(j-displayoffsety)*tilesize,(i-displayoffsetx)*tilesize+tilesize-1+100,(j-displayoffsety)*tilesize+tilesize-1-tilesize/4,makecol(0,0,0));							
							break;	
						case Z://right
							rectfill(buffer,(i-displayoffsetx)*tilesize+100,(j-displayoffsety)*tilesize+tilesize/4,(i-displayoffsetx)*tilesize+tilesize-1+100-tilesize/4,(j-displayoffsety)*tilesize+tilesize-1,makecol(0,0,0));							
							break;	
						case C://right
							rectfill(buffer,(i-displayoffsetx)*tilesize+100+tilesize/4,(j-displayoffsety)*tilesize+tilesize/4,(i-displayoffsetx)*tilesize+tilesize-1+100,(j-displayoffsety)*tilesize+tilesize-1,makecol(0,0,0));							
							break;								
					};
			}
		
		/* control timing */
		while (ticks<1)
		{
			rest(0);
		}
		ticks=0;
		++frames;
		
		blit(buffer,screen, 0,0,0,0,800,600);
		
	}	
	
	
	
	deinit();
	return 0;
}
END_OF_MAIN()

void init() {
	int depth, res;
	allegro_init();
	depth = desktop_color_depth();
	if (depth == 0) depth = 32;
	set_color_depth(depth);
	res = set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 800, 600, 0, 0);
	if (res != 0) {
		allegro_message(allegro_error);
		exit(-1);
	}
	
	install_timer();
	install_keyboard();
	install_mouse();
	
	if (install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL) != 0) {
		allegro_message("Error initialising sound system\n%s\n", allegro_error);
	}
	
	
	sound[0] = load_wav("finish.wav");                       
	sound[1] = load_wav("shoot.wav");            
	sound[2] = load_wav("fail.wav");            
	
	LOCK_FUNCTION(second_counter);
	LOCK_VARIABLE(fps);
	LOCK_VARIABLE(frames);
	LOCK_FUNCTION(ticker);
	LOCK_VARIABLE(ticks);
	
	
	frames=timewaster_delay=0;
	install_int_ex(second_counter, BPS_TO_TIMER(1));
	install_int_ex(ticker, BPS_TO_TIMER(10));
	
	
	int white=makecol(255,255,255);
	int offwhite=makecol(192,192,192);  
	int black=makecol(0,0,0);
	int blue=makecol(0,0,255);
	int pink=makecol(255,200,200);
	int aqua=makecol(200,200,255);
	//	int red=makecol(255,0,0);
	int green=makecol(0,255,0);
	int purple=makecol(255,0,255);
	int grey=makecol(80,80,80);
	int darkgrey=makecol(40,40,40);
	int yellow=makecol(255,255,0);
	int brown=makecol(93,40,11);
	int darkyellow=makecol(128,128,0);
	int bggrey=makecol(50,50,50);
	colorkey[0]=black; //nothingness
	colorkey[1]=black; //Start point
	colorkey[2]=yellow; //Finish point
	colorkey[3]=darkgrey; //hollowwall
	colorkey[4]=white; //wall
	colorkey[5]=white;   //wall up
	colorkey[6]=white;  //wall down
	colorkey[7]=white;  //wall left
	colorkey[8]=white;  //wall right
	colorkey[9]=white;   //wall up
	colorkey[10]=white;  //wall down
	colorkey[11]=white;  //wall left
	colorkey[12]=white;  //wall right	
	colorkey[13]=grey;//background
	colorkey[14]=green;  //player
	colorkey[15]=black;  //background grey
	colorkey[16]=bggrey;//lethal gass, penetrable by portal
	colorkey[17]=offwhite;//see how looks for mirror walls
	colorkey[18]=brown;//boulder
	colorkey[19]=darkyellow;//entrance
	colorkey[20]=black;//boulder roll left spawn point
	buffer=create_bitmap(800,600);
	//        bg=create_bitmap(800,600);        
	curlevel=0;
	
	initlevel();
}

void deinit() {
	clear_keybuf();
	/* add other deinitializations here */
}
